import { ConnectorBase, Query, Mutation } from "@0xcert/scaffold";
import { SignMethod } from "./types";
export interface ConnectorAttachOptions {
    makerId?: string;
    minterId?: string;
    exchangeId?: string;
    signMethod?: SignMethod;
    web3?: any;
}
export declare class Connector implements ConnectorBase {
    readonly platform: string;
    makerId: string;
    minterId?: string;
    exchangeId?: string;
    signMethod: SignMethod;
    web3: any;
    attach(options?: ConnectorAttachOptions): Promise<this>;
    detach(): Promise<this>;
    sign(data: string): Promise<string>;
    query<T>(resolver: () => Promise<T>): Promise<Query<T>>;
    mutate(resolver: () => any): Promise<Mutation>;
    protected getWeb3(web3?: any): any;
    protected getAccounts(): Promise<any>;
    protected getMakerId(makerId?: string): Promise<string>;
    protected getSignMethod(signMethod?: SignMethod): SignMethod;
    protected signData(data: string): Promise<any>;
}
