"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var scaffold_1 = require("@0xcert/scaffold");
var web3_error_parser_1 = require("@0xcert/web3-error-parser");
var Web3 = require("web3");
var types_1 = require("./types");
var Connector = (function () {
    function Connector() {
        this.platform = 'web3';
    }
    Connector.prototype.attach = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        options = options || {};
                        this.web3 = this.getWeb3(options.web3);
                        _a = this;
                        return [4, this.getMakerId(options.makerId)];
                    case 1:
                        _a.makerId = _c.sent();
                        this.minterId = options.minterId || '0x';
                        this.exchangeId = options.exchangeId || '0x';
                        _b = this;
                        return [4, this.getSignMethod(options.signMethod)];
                    case 2:
                        _b.signMethod = _c.sent();
                        return [2, this];
                }
            });
        });
    };
    Connector.prototype.detach = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.web3 = null;
                this.makerId = null;
                this.signMethod = null;
                this.minterId = null;
                this.exchangeId = null;
                return [2, this];
            });
        });
    };
    Connector.prototype.sign = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.signMethod + ":";
                        return [4, this.signData(data)];
                    case 1: return [2, _a + (_b.sent())];
                }
            });
        });
    };
    Connector.prototype.query = function (resolver) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        _a = {};
                        return [4, resolver()];
                    case 1: return [2, (_a.result = _b.sent(),
                            _a)];
                    case 2:
                        error_1 = _b.sent();
                        throw web3_error_parser_1.parseError(error_1);
                    case 3: return [2];
                }
            });
        });
    };
    Connector.prototype.mutate = function (resolver) {
        return __awaiter(this, void 0, void 0, function () {
            var error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, new Promise(function (resolve, reject) {
                                var obj = resolver();
                                obj.once('transactionHash', function (hash) { return resolve({ hash: hash }); });
                                obj.once('error', reject);
                            }).then(function (d) {
                                return d;
                            })];
                    case 1: return [2, _a.sent()];
                    case 2:
                        error_2 = _a.sent();
                        throw web3_error_parser_1.parseError(error_2);
                    case 3: return [2];
                }
            });
        });
    };
    Connector.prototype.getWeb3 = function (web3) {
        return web3 ? web3 : new Web3('ws://localhost:8545');
    };
    Connector.prototype.getAccounts = function () {
        return __awaiter(this, void 0, void 0, function () {
            var error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, this.web3.eth.getAccounts()];
                    case 1: return [2, _a.sent()];
                    case 2:
                        error_3 = _a.sent();
                        throw web3_error_parser_1.parseError(error_3);
                    case 3: return [2];
                }
            });
        });
    };
    Connector.prototype.getMakerId = function (makerId) {
        return __awaiter(this, void 0, void 0, function () {
            var accounts;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.getAccounts()];
                    case 1:
                        accounts = _a.sent();
                        if (makerId === undefined) {
                            makerId = accounts[0];
                        }
                        if (accounts.indexOf(makerId) === -1) {
                            throw new scaffold_1.ConnectorError(scaffold_1.ConnectorIssue.INVALID_MAKER_ID);
                        }
                        return [2, makerId];
                }
            });
        });
    };
    Connector.prototype.getSignMethod = function (signMethod) {
        if (signMethod === undefined) {
            signMethod = types_1.SignMethod.ETH_SIGN;
        }
        if ([0, 1, 2].indexOf(signMethod) === -1) {
            throw new scaffold_1.ConnectorError(scaffold_1.ConnectorIssue.SIGNATURE_UNKNOWN, "Unknown signature method " + signMethod);
        }
        return signMethod;
    };
    Connector.prototype.signData = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, error_4;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 7, , 8]);
                        _a = this.signMethod;
                        switch (_a) {
                            case types_1.SignMethod.ETH_SIGN: return [3, 1];
                            case types_1.SignMethod.TREZOR: return [3, 3];
                            case types_1.SignMethod.EIP712: return [3, 4];
                        }
                        return [3, 5];
                    case 1: return [4, this.web3.eth.sign(data, this.makerId)];
                    case 2: return [2, _b.sent()];
                    case 3: return [2, ''];
                    case 4: return [2, ''];
                    case 5: return [2, null];
                    case 6: return [3, 8];
                    case 7:
                        error_4 = _b.sent();
                        throw new scaffold_1.ConnectorError(scaffold_1.ConnectorIssue.SIGNATURE_FAILED, error_4);
                    case 8: return [2];
                }
            });
        });
    };
    return Connector;
}());
exports.Connector = Connector;
//# sourceMappingURL=connector.js.map