import { ContextBase, Query, Mutation } from "@0xcert/scaffold";
import { SignMethod } from "./types";
export interface ContextOptions {
    exchangeId?: string;
    myId?: string;
    signMethod?: SignMethod;
    web3: any;
}
export declare class Context implements ContextBase {
    exchangeId?: string;
    myId: string;
    signMethod: SignMethod;
    web3: any;
    constructor(options: ContextOptions);
    attach(): Promise<this>;
    detach(): Promise<this>;
    sign(data: string): Promise<string>;
    query<T>(resolver: () => Promise<T>): Promise<Query<T>>;
    mutate(resolver: () => Promise<any>, from?: string): Promise<Mutation>;
    transfer(data: {
        value: number;
        to: string;
    }, from?: string): Promise<Mutation>;
    protected getAccounts(): Promise<any>;
    protected getAccountId(accountid?: string): Promise<string>;
    protected getSignMethod(signMethod?: SignMethod): SignMethod;
    protected signData(data: string): Promise<any>;
}
