"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const spec_1 = require("@specron/spec");
const context_1 = require("../../../core/context");
const spec = new spec_1.Spec();
spec.before((stage) => __awaiter(this, void 0, void 0, function* () {
    const context = new context_1.Context(stage);
    yield context.attach();
    stage.set('context', context);
}));
spec.test('wipes context data', (ctx) => __awaiter(this, void 0, void 0, function* () {
    const context = ctx.get('context');
    yield context.detach();
    ctx.is(context.myId, null);
    ctx.is(context.signMethod, null);
    ctx.is(context.web3, null);
}));
exports.default = spec;
//# sourceMappingURL=detach-instance-method.test.js.map